//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Masks.hpp"
#include <FileCtrl.hpp>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   for(int i=0; i<MAX_BITMAP; i++)
   {
      gbmp[i]=NULL;
      gbmp[i]=new Graphics::TBitmap;
      gbmp[i]->LoadFromFile(IntToStr(i)+".bmp");
   }

   GroupBox1->DoubleBuffered=true;
   Image1->Width=gbmp[0]->Width;
   Image1->Height=gbmp[0]->Height;
   Image1->Stretch=true;
   Image1->Picture->Bitmap->TransparentColor=clWhite;
   Image1->Transparent=true;
   Image1->Picture->Assign(gbmp[0]);

   Timer1->Enabled=false;
   Timer1->Interval=500;

   giIndex=0;
   gbStop=true;
   giDir=0;
   Label6->Caption=IntToStr(giDir);
   giFile=0;
   Label8->Caption=IntToStr(giFile);
   giFind=0;
   Label11->Caption=IntToStr(giFind);
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
   gbStop=true;
   Timer1->Enabled=false;
   for(int i=0; i<MAX_BITMAP; i++)
   {
      if(gbmp[i]!=NULL)
      {
         delete gbmp[i];
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   Image1->Picture->Bitmap->TransparentColor=clWhite;
   Image1->Transparent=true;
   Image1->Picture->Assign(gbmp[giIndex]);
   giIndex++;
   if(giIndex>=MAX_BITMAP)
   {
      giIndex=0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SearchFiles(AnsiString szDir, TStringList *slFile, TStringList *slText)
{
   TSearchRec SearchRec;
   int iAttr=faAnyFile;
   int iFound=0;

   if(!DirectoryExists(szDir) || gbStop)
   {
      return;
   }
   if(szDir.SubString(szDir.Length(), 1)!="\\")
   {
      szDir=szDir+"\\";
   }
   Application->ProcessMessages();
   iFound=FindFirst(szDir+"*.*", iAttr, SearchRec);
   while(iFound==0)
   {
      if(SearchRec.Attr==faDirectory)
      {
         if((SearchRec.Name!=".") && (SearchRec.Name!=".."))
         {
            giDir++;
            Label6->Caption=IntToStr(giDir);
            SearchFiles(szDir+SearchRec.Name, slFile, slText);
         }
      }
      else
      {
         bool bFile=false;
         bool bText=true;

         giFile++;
         Label8->Caption=IntToStr(giFile);

         for(int i=0; i<slFile->Count; i++)
         {
            if(MatchesMask(SearchRec.Name, slFile->Strings[i]))
            {
               bFile=true;
               break;
            }
            Application->ProcessMessages();
         }

         if(slText!=NULL && bFile)
         {
            bText=false;
            TStringList *sl=new TStringList;
            try
            {
               try
               {
                  sl->LoadFromFile(szDir+SearchRec.Name);
                  for(int j=0; j<sl->Count; j++)
                  {
                     if(bText)
                     {
                        break;
                     }
                     for(int k=0; k<slText->Count; k++)
                     {
                        if(sl->Strings[j].AnsiPos(slText->Strings[k])>0)
                        {
                           bText=true;
                           break;
                        }
                        Application->ProcessMessages();
                     }
                  }
               }
               catch(Exception &e)
               {
                  //...nothing to do...
               }
            }
            __finally
            {
               delete sl;
            }
         }

         if(bFile && bText)
         {
            TListItem *li=ListView1->Items->Add();
            li->ImageIndex=0;
            li->Caption=szDir+SearchRec.Name;
            li->SubItems->Add(IntToStr(SearchRec.Size));
            TDateTime dt=FileDateToDateTime(SearchRec.Time);
            li->SubItems->Add(dt.DateTimeString());

            giFind++;
            Label11->Caption=IntToStr(giFind);
         }
      }
      iFound=FindNext(SearchRec);
   }
   FindClose(SearchRec);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   if(Trim(Edit1->Text)=="")
   {
      ShowMessage("ujMW١v줣iť!!");
      return;
   }
   if(Trim(Edit3->Text)=="")
   {
      ShowMessage("ujMؿv줣iť!!");
      return;
   }

   Label4->Caption="bjM...";
   giDir=0;
   Label6->Caption=IntToStr(giDir);
   giFile=0;
   Label8->Caption=IntToStr(giFile);
   giFind=0;
   Label11->Caption=IntToStr(giFind);

   gbStop=false;
   ListView1->Items->Clear();
   Button1->Enabled=false;
   Timer1->Enabled=true;
   TStringList *slFile=NULL;
   slFile=new TStringList;
   AnsiString szFile=Trim(Edit1->Text);
   szFile=StringReplace(szFile, " ", ",", TReplaceFlags()<<rfReplaceAll);
   slFile->CommaText=szFile;
   TStringList *slText=NULL;
   AnsiString szText=Trim(Edit2->Text);
   if(szText!="")
   {
      slText=new TStringList;
      szText=StringReplace(szText, " ", ",", TReplaceFlags()<<rfReplaceAll);
      slText->CommaText=szText;
   }
   SearchFiles(Edit3->Text, slFile, slText);
   if(slText)
   {
      delete slText;
   }
   if(slFile)
   {
      delete slFile;
   }
   Timer1->Enabled=false;
   Label4->Caption="jM...";
   Button1->Enabled=true;
   gbStop=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   gbStop=true;
   Timer1->Enabled=false;
   Label4->Caption="jM...";
   Button1->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   Button2->Click();
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   AnsiString szDir;
   if(SelectDirectory("ܥؿ", "", szDir))
   {
      Edit3->Text=szDir;
   }
}
//---------------------------------------------------------------------------

